Bug 238192

Summary: sysutils/qjail: Cannot fetch arm64 from FreeBSD mirrors (old directory layout)
Product: Ports & Packages Reporter: Igor Konov <montblanc>
Component: Individual Port(s)Assignee: freebsd-ports-bugs mailing list <ports-bugs>
Status: Open ---    
Severity: Affects Some People CC: arrowd, qjail1, releng
Priority: --- Keywords: needs-qa
Version: Latest   
Hardware: arm64   
OS: Any   
Attachments:
Description Flags
diff file to fix bug none

Description Igor Konov 2019-05-28 13:57:34 UTC
Created attachment 204670 [details]
diff file to fix bug

# qjail install
resolving server address: ftp2.freebsd.org:80
requesting http://ftp2.freebsd.org/pub/FreeBSD/releases/aarch64/aarch64/12.0-RELEASE/base.txz

404 Not Found

404 Not Found
nginx


fetch: http://ftp2.freebsd.org/pub/FreeBSD/releases/aarch64/aarch64/12.0-RELEASE/base.txz: Not Found
Error: Failed to ftp base.txz file.
ftp ftp2.freebsd.org:pub/FreeBSD/releases/aarch64/aarch64/12.0-RELEASE/base.txz
If your host is running an BETA or RC build update host to RELEASE.
Comment 1 Joe Barbish 2019-05-29 15:39:12 UTC
Thank you for reporting what you think is a bug.

I would like to know if after getting "qjail install" command to work using your patch does qjail work normally on arm64 machine architecture? To my knowledge you are the first to try it there.

If you review the readme file http://ftp.freebsd.org/pub/FreeBSD/releases/README.TXT
you get this text.

CONTENTS:
---------

ISO-IMAGES/
	Most users will want to retrieve CD-ROM and DVD ISO images from this
	top-level directory.

FreeBSD releases are identified by a high-level machine type and machine
target architecture:

	amd64/amd64			Intel/AMD x86_64 (64-bit)
	i386/i386			Intel/AMD x86 (32-bit)
	ia64/ia64			Intel Itanium
	powerpc/powerpc			32-bit PowerPC
	powerpc/powerpc64		64-bit PowerPC
	sparc64/sparc64			Sparc64

Historically, only machine type was used; those directories also exist to
hold older releases using that scheme:

	amd64
	i386
	ia64
	pc98				(Desupported)
	powerpc
	sparc64 

If you review the directory layout of any ftp.freebsd.org/pub/FreeBSD/releases servers you will see that arm64 is of the old directory type.

Qjail does not support this old directory layout and I will not add support for it to qjail after previously removing it when the change over was made back around release 7.0. You can tell from this that your usage of qjail is a very uncommon special usage case.
 
I suggest you contact the support group of arm64 and have then update the directory layout to the newer layout. Or report the old arm64 directory tree layout as a bug.

The qjail work around is documented in the qjail manual under the 
"qjail install -f" option.
Or you can keep your patch for your personal qjail usage.

Thank you for using qjail.
Comment 2 Joe Barbish 2019-05-29 15:44:32 UTC
Comment on attachment 204670 [details]
diff file to fix bug

Patch rejected because this bug is not qjail code problem. See maintainer comment in bug body.
Comment 3 Joe Barbish 2019-05-29 15:52:05 UTC
This bug can be closed as INVALID.
Comment 4 Kubilay Kocak freebsd_committer freebsd_triage 2019-06-05 04:47:20 UTC
Re-open per comment 1. Hopefully mirror-admin / clusteradm / releng can resolve the issue
Comment 5 Antoine Brodin freebsd_committer 2019-06-05 12:11:10 UTC
This is a bug in qjail,  it should fetch from arm64/aarch64 directory.
Comment 6 Igor Konov 2019-06-05 16:57:34 UTC
(In reply to Antoine Brodin from comment #5)

Patch attached:
https://bz-attachments.freebsd.org/attachment.cgi?id=204670
Comment 7 Igor Konov 2019-07-09 18:12:49 UTC
Up
Comment 8 Gleb Popov freebsd_committer 2019-08-01 13:06:49 UTC
This patch doesn't apply. Is it reversed?

Current qjail version contains 

installarch="${installarch}/${installarch}"

line already.